#ifndef AUDISPD_H
#define AUDISPD_H 1

#include "evnt.h"
#include "vlg.h"
#include "opt_serv.h"
#include "opt_policy.h"

#define AUDISPD_CONF_MAX_WAIT_SEND 16

#define AUDISPD_CONF_RECV_CALL_LIMIT 4
#define AUDISPD_CONF_SEND_CALL_LIMIT 1

#define AUDISPD_CONF_DEF_LISTEN "/var/run/audit_events"
#define AUDISPD_CONF_DEF_USR_LISTEN "./audit_events"

#define AUDISPD_CONF_MAX_CMDS     32
#define AUDISPD_CONF_MAX_CMD_ARGS  8

#define AUDISPD_CONF_MAX_MSGS 0
/* #define MAX_AUDIT_MESSAGE_LENGTH 8970 - PATH_MAX*2+CONTEXT_SIZE*2+11+256+1 */
#define AUDISPD_CONF_MAX_DATA (1024 * 8 * 32)

#define AUDISPD_CONF_TYPE_LIM_REACHED AUDISPD_TYPE_LIM_REACHED_DROP

#define AUDISPD_CONF_TYPE_MAN_CON_DIED AUDISPD_TYPE_MAN_CON_DIED_RESTART

#define AUDISPD_TYPE_LIM_REACHED_DROP  0
#define AUDISPD_TYPE_LIM_REACHED_CLOSE 1
#define AUDISPD_TYPE_LIM_REACHED_STOP  2

#define AUDISPD_TYPE_MAN_CON_DIED_RESTART 0
#define AUDISPD_TYPE_MAN_CON_DIED_IGNORE  1
#define AUDISPD_TYPE_MAN_CON_DIED_CASCADE 2

typedef struct Audispd_policy_opts
{
 Opt_serv_policy_opts s[1];

 unsigned int max_header_sz;

 unsigned int max_msgs;
 unsigned int max_data;

 int *filts;
 unsigned int filt_sz;
 unsigned int filt_num;
 
 unsigned int limit_reached    : 4;
 unsigned int managed_con_died : 4;
} Audispd_policy_opts;

typedef struct Audispd_cmd
{
 Vstr_base *name;
 Vstr_base *path;

 unsigned int arg_num;
 Vstr_base *args[AUDISPD_CONF_MAX_CMD_ARGS]; /* FIXME: needs to be dynamic */

 Vstr_base *def_policy;
} Audispd_cmd;

typedef struct Audispd_opts
{
 Opt_serv_opts s[1];
 
 time_t beg_time;
 
 Conf_parse *conf;
 unsigned int conf_num;

 Vstr_base *main_input;

 Audispd_cmd cmds[AUDISPD_CONF_MAX_CMDS]; /* FIXME: needs to be dynamic */
 unsigned int cmd_num;

 Conf_token match_connection[1];
 Conf_token tmp_match_connection[1];
 Conf_token match_audit_line[1];
 Conf_token tmp_match_audit_line[1];
} Audispd_opts;
#define AUDISPD_CONF_DECL_OPTS(N)                               \
    Audispd_opts N[1] = {                                       \
     {                                                          \
      {{OPT_SERV_CONF_INIT_OPTS(PACKAGE, VERSION)}},            \
      (time_t)-1,                                               \
      NULL,                                                     \
      0,                                                        \
      NULL,                                                     \
      {{NULL,NULL,0,{NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL},NULL},    \
       {NULL,NULL,0,{NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL},NULL},    \
       {NULL,NULL,0,{NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL},NULL},    \
       {NULL,NULL,0,{NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL},NULL},    \
       {NULL,NULL,0,{NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL},NULL},    \
       {NULL,NULL,0,{NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL},NULL},    \
       {NULL,NULL,0,{NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL},NULL},    \
       {NULL,NULL,0,{NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL},NULL},    \
       {NULL,NULL,0,{NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL},NULL},    \
       {NULL,NULL,0,{NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL},NULL},    \
       {NULL,NULL,0,{NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL},NULL},    \
       {NULL,NULL,0,{NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL},NULL},    \
       {NULL,NULL,0,{NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL},NULL},    \
       {NULL,NULL,0,{NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL},NULL},    \
       {NULL,NULL,0,{NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL},NULL},    \
       {NULL,NULL,0,{NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL},NULL},    \
       {NULL,NULL,0,{NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL},NULL},    \
       {NULL,NULL,0,{NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL},NULL},    \
       {NULL,NULL,0,{NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL},NULL},    \
       {NULL,NULL,0,{NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL},NULL},    \
       {NULL,NULL,0,{NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL},NULL},    \
       {NULL,NULL,0,{NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL},NULL},    \
       {NULL,NULL,0,{NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL},NULL},    \
       {NULL,NULL,0,{NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL},NULL},    \
       {NULL,NULL,0,{NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL},NULL},    \
       {NULL,NULL,0,{NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL},NULL},    \
       {NULL,NULL,0,{NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL},NULL},    \
       {NULL,NULL,0,{NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL},NULL},    \
       {NULL,NULL,0,{NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL},NULL},    \
       {NULL,NULL,0,{NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL},NULL},    \
       {NULL,NULL,0,{NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL},NULL},    \
       {NULL,NULL,0,{NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL},NULL}},   \
      0,                                                        \
      {CONF_TOKEN_INIT},                                        \
      {CONF_TOKEN_INIT},                                        \
      {CONF_TOKEN_INIT},                                        \
      {CONF_TOKEN_INIT},                                        \
     }                                                          \
    }

struct Con
{
 struct Evnt evnt[1];

 Vstr_base *tag;
 
 const Audispd_policy_opts *policy;

 Audispd_cmd *managed;
 
 unsigned int io_limit_num : 8;
 
 unsigned int flag_drop_msgs : 1;

 struct Con *prev;
 struct Con *next;
};
#define CON_CEVNT_SA(x)     EVNT_SA((x)->evnt)
#define CON_CEVNT_SA_IN4(x) EVNT_SA_IN4((x)->evnt)
#define CON_CEVNT_SA_IN6(x) EVNT_SA_IN6((x)->evnt)
#define CON_CEVNT_SA_UN(x)  EVNT_SA_UN((x)->evnt)

#define CON_SEVNT_SA(x)     EVNT_ACPT_SA((x)->evnt)
#define CON_SEVNT_SA_IN4(x) EVNT_ACPT_SA_IN4((x)->evnt)
#define CON_SEVNT_SA_IN6(x) EVNT_ACPT_SA_IN6((x)->evnt)
#define CON_SEVNT_SA_UN(x)  EVNT_ACPT_SA_UN((x)->evnt)

#ifdef AUDISPD_HAVE_GLOBAL_OPTS
extern Audispd_opts audispd_opts[1]; /* hacky ... */
#endif

#include "audispd_conf.h"

#endif
